/**
 * Memoizes the provided three-argument or more function based on the first three arguments.
 */
export declare function memoize3<
  A1 extends object,
  A2 extends object,
  A3 extends object,
  V extends Array<any>,
  R,
>(
  fn: (a1: A1, a2: A2, a3: A3, ...rest: V) => R,
): (a1: A1, a2: A2, a3: A3, ...rest: V) => R;
